import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

Minim minim;
AudioInput input;
FFT fft;
float frequency;
float max;

void setup() {
  size(800, 800);
  frameRate(30);
  
  minim = new Minim(this);
  
  // Use the microphone
  input = minim.getLineIn();
}

void draw() {
  background(255);
  
  stroke(0);
  
  // Make an FFT for each frame
  fft = new FFT(input.bufferSize(), input.sampleRate());
  fft.linAverages(10); // Like a 10 band graphic equalizer
  fft.forward(input.mix); // Go through the buffer
  
  for (int i = 0; i < fft.avgSize(); i++) {
    // Get the average value in each band
    frequency = fft.getAvg(i);
  }
  
  // Use the average to mulitply by a gray-scale value - darker is higher
  fill((1-frequency)*255);
  ellipse(width/2, height/2, width, height);
  
  noFill();
  for (int i = 0; i < input.bufferSize(); i++) {
    // Base the size of circles in the amplitude of each sample
    float sample = input.mix.get(i);
    stroke(0, 30);
    ellipse(width/2, height/2, sample*width, sample*height);
  }
}
